import java.util.*;

/* Un API (con Valore Astratto e specifica) per
 relazioni IMMUTABLE presentata il 17/5/2016
 */

class invalidArgException extends Exception{
}

interface MuRelazioneAPIX<A,B> {
    //Introduce Valori Astratti {(x,y)| x\in[A], y\in[B]} Mutable
    //Sia O un oggetto di elazioneJAPI<A,B>, Va(O) \`e il valore astratto definito da O.
    public void addPair(A x, B y) throws invalidArgException;
        //Solleva eccezione se (x=null)||(y=null)
        //modifica this in modo tale che: Sia thisPre e thisPost il valore di this prima
        //e dopo l'invocazione, risp.
        // (1) forall(u,v), if thisPres.isIn(u,v) then ThisPost.isIn(u,v)
        // (2) if !thisPre.isIn(u,v) && thisPost.isIn(u,v) then (u,v)=(x,y)
    public void removePair (A x, B y) throws invalidArgException;
        //Solleva eccezione ...
        //calcola Va tale che: ....
    public boolean isIn(A x, B y) throws invalidArgException;
        //Solleva eccezione se (x=null)||(y=null)
        //calcola true sse (x,y)\in Va(this)
}
