import java.lang.*;
import java.io.*;
import java.util.*;

/* AltriEsercizi8 - Esercizio2 del 16/5/2016
 Si definisca in Java una tipo astratto per relazioni binarie, su tipi generici, 
 come quelle in esercizio1 ma per valori MODIFICABILI e con le sole operazioni 
 addPair, removePair, isIn. In particolare, si fornisca:\\
 (a) Interfaccia API;\\
 (b) Intestazione della classe;\\
 (c) Stato Concreto;\\
 (e) AF, I;\\
 (f) Definizione dei metodi addPair, removePair, isIn;\\
 (g) Trattamento degli Additionals (clone, equals, toString, elements);\\
 (h) Una versione adatta dei casi d'uso discussi in esercizio1.
*/

/* punto (g) */

class main{
    public static <A> boolean simm(MuRelazioneADTX<A,A> r){//
        //notare l'introduzione della generica <A> locale alla definizione
        // del metodo. In alternativa, l'introduzione doveva essere fatta
        // nell'intestazione della classe.
        LinkedList<ImPairADTX<A,A>> elem = r.elements();
        for(ImPairADTX<A,A> u: elem){
            try{if (!r.isIn(u.getRight(),u.getLeft())) return false;}
            catch(invalidArgException e){}
        }
        return true;
    }
    public static <A,B> boolean incl(MuRelazioneADTX<A,B> r, MuRelazioneADTX<A,B> s){//
        //notare l'introduzione delle generiche <A,B> locali alla definizione
        // del metodo. In alternativa, l'introduzione doveva essere fatta
        // nell'intestazione della classe.
        LinkedList<ImPairADTX<A,B>> elem = r.elements();
        for(ImPairADTX<A,B> u: elem){
            try{if (!s.isIn(u.getLeft(),u.getRight())) return false;}
            catch(invalidArgException e){}
        }
        return true;
    }
    public static void main(String args[]) throws invalidArgException,CloneNotSupportedException {
        MuRelazioneADTX<Integer,Integer> shortest = new MuRelazioneADTX<Integer,Integer>();
        shortest.addPair(3,-5);
        System.out.println("E' shortest simmetrica? -- " + (main.simm(shortest)?"SI":"NO"));
        shortest.addPair(-5,3);
        System.out.println("E' shortest simmetrica? -- " + (main.simm(shortest)?"SI":"NO"));
        MuRelazioneADTX<Integer,Integer> shortest1 = new MuRelazioneADTX<Integer,Integer>();
        shortest1.addPair(-5,3);
        System.out.println("E' shortest1 inclusa in shortest? -- " + (incl(shortest1,shortest)?"SI":"NO"));
        System.out.println("E' shortest inclusa in shortest1? -- " + (incl(shortest,shortest1)?"SI":"NO"));
        
    }
}

